/*****************************************************************************
* Copyright (c) 1990-2000 Digi International Inc., All Rights Reserved
* 
* This software contains proprietary and confidential information of Digi
* International Inc.  By accepting transfer of this copy, Recipient agrees
* to retain this software in confidence, to prevent disclosure to others,
* and to make no use of this software other than that for which it was
* delivered.  This is an unpublished copyrighted work of Digi International
* Inc.  Except as permitted by federal law, 17 USC 117, copying is strictly
* prohibited.
* 
* Restricted Rights Legend
*
* Use, duplication, or disclosure by the Government is subject to
* restrictions set forth in sub-paragraph (c)(1)(ii) of The Rights in
* Technical Data and Computer Software clause at DFARS 252.227-7031 or
* subparagraphs (c)(1) and (2) of the Commercial Computer Software -
* Restricted Rights at 48 CFR 52.227-19, as applicable.
*
* Digi International Inc. 11001 Bren Road East, Minnetonka, MN 55343
*
*****************************************************************************/

#ifndef DBGPRINTF_H
#define DBGPRINTF_H

static const char dbgprintf_h_rcsid[] = "@(#) " "$Id: dbgprintf.h,v 1.4 2000/04/19 22:45:47 chrism Exp $";

void error_printf(char const * const fmt, ...);
#define errprintf error_printf

#if defined(DEBUG) || defined(_DEBUG)
#define TRCPRINTF
#endif

#if defined TRCPRINTF

void trace_printf(char const * const fmt, ...);
#define trcprintf trace_printf

#else

#if defined PLATFORM_WINDOWS
#define INLINE __inline
#else
#define INLINE
#endif

static INLINE void dummy_printf(char const * const fmt, ...) { }
#define trcprintf (1) ? (void)0 : dummy_printf

#endif /* NDEBUG */

#endif /* DBGPRINTF_H */
