#
# Copyright 1999 by Digi International (www.digi.com)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, EXPRESS OR IMPLIED; without even the
# implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

#
#       $Id: dm_osdep_linux.tcl.inc,v 1.5 2000/11/03 07:05:05 jamesp Exp $
#
package provide dm_gui 1.0

#
# Here are where O/S dependant #define like things go:
#
set CAN_DO_CALL_MONITOR 1
set CAN_DO_VWAIT_UPDATE 1

#
# osdep_open_mgmt: opens the mgmt device particular to an O/S
#
proc osdep_open_mgmt { bn } {
	global mgmt

	set mgmt($bn) [ openfd /dev/dg/dgdm/mgmt$bn 2 ]
}


#
# get_device_name: returns the name of a device given:
#
#	An adapter type "type"
#	A board number "bn"
#	A port number "pn"
#	A channel number "cn"
#
proc get_device_name { type bn pn cn } {
	# Adapter type does not matter in Linux:
	set dn "ttyG${bn}_"
	
	# Pad zeros to two places
	if { $cn < 10 } {
		set dn "${dn}0"
	}

	set dn "${dn}$cn"

	return $dn
}


#
# update_portreg
#
# update_portreg updates the persistent port setting database with
# the values just configured by the user by calling an external
# application (typically dm_portreg or equivalent).  This application
# should query the adapter for the current settings and apply them
# to the persistent database.  We assume that only one channel is
# available per port... which means this only works for existing
# Xp products and nothing else.
#
# The parameters:
#
#	A board number "bn"
#	A port number "pn"  (zero based)
#
# REMEMBER to change the "dm_portreg" path to be appropriate for each
# specific OS environment.
#
proc update_portreg { bn pn } {
	global adapter_info

	set ai $adapter_info($bn)
	set sn [any2str [adapter_info_t_main_board_serial_get $ai]]

### TODO: -- add appropriate linux path here!
	exec /usr/bin/dm_portreg -c $sn $pn
}
